'''
minify use case packages
1.0.0.json == minified
1.0.0-pretty.json == readable
'''
import json
from pathlib import Path

print('START')
EXAMPLES_DIR = Path('.')
paths = [dir / '1.0.0-pretty.json' for dir in EXAMPLES_DIR.iterdir() if dir.is_dir()]

def rename_strict_to_pretty(file_path):
    target = file_path.parent / '1.0.0-pretty.json'
    file_path.rename(target)
    return target

def create_strict_from_pretty(file_path):
    minified = minify(file_path)
    strict_path = file_path.parent / '1.0.0.json'
    strict_path.write_text(minified)

def minify(file_name):
    file_data = open(file_name).read()
    json_data = json.loads(file_data)
    json_string = json.dumps(json_data, separators=(',', ':'), sort_keys=True)
    return json_string

for path in paths:
    pretty_path = rename_strict_to_pretty(path)
    create_strict_from_pretty(path)
print('DONE')


'''
from ethpm-spec/examples
run python3 minify_pkgs.py
'''


