/**
 * This file was automatically generated by json-schema-to-typescript.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
 * and run json-schema-to-typescript to regenerate this file.
 */

/**
 * EthPM Manifest Version
 */
export type ManifestVersion = "2";
/**
 * The name of the package that this release is for
 */
export type PackageName = string;
/**
 * Authors of this package
 */
export type Authors = string[];
/**
 * The license that this package and it's source are released under
 */
export type License = string;
/**
 * Description of this package
 */
export type Description = string;
/**
 * Keywords that apply to this package
 */
export type Keywords = string[];
export type Version = string;
export type SourceCode = string;
/**
 * The name for this contract type as found in the project source code.
 */
export type ContractName = string;
export type BytecodeObject = {
  [k: string]: any;
};
/**
 * The ABI for this contract type
 */
export type Abi = any[];
/**
 * The contract type of this contract instance
 */
export type ContractTypeName = string;
/**
 * An Ethereum address
 */
export type Address = ByteString & {
  [k: string]: any;
};
/**
 * 0x-prefixed hexadecimal string representing bytes
 */
export type ByteString = string;
/**
 * An Ethereum transaction hash
 */
export type TransactionHash = ByteString & {
  [k: string]: any;
};
/**
 * An Ethereum block hash
 */
export type BlockHash = ByteString & {
  [k: string]: any;
};
/**
 * A value for an individual link reference in a contract's bytecode
 */
export type LinkValue =
  | {
      type?: "literal";
      value?: ByteString;
      [k: string]: any;
    }
  | {
      type?: "reference";
      value?: ContractInstanceName | PackageContractInstanceName;
      [k: string]: any;
    };
/**
 * The name of the deployed contract instance
 */
export type ContractInstanceName = string;
/**
 * The path to a deployed contract instance somewhere down the dependency tree
 */
export type PackageContractInstanceName = string;
/**
 * The values for the link references found within this contract instances runtime bytecode
 */
export type LinkDependencies = LinkValue[];
/**
 * An content addressable URI
 *
 * This interface was referenced by `BuildDependencies`'s JSON-Schema definition
 * via the `patternProperty` "^[a-z][-a-z0-9]{0,255}$".
 */
export type ContentUri = string;

/**
 * EthPM Manifest Specification
 */
export interface PackageManifest {
  manifest_version: ManifestVersion;
  package_name: PackageName;
  meta?: PackageMeta;
  version: Version;
  sources?: Sources;
  contract_types?: ContractTypes;
  deployments?: Deployments;
  build_dependencies?: BuildDependencies;
  [k: string]: any;
}
/**
 * Metadata about the package
 */
export interface PackageMeta {
  authors?: Authors;
  license?: License;
  description?: Description;
  keywords?: Keywords;
  links?: Links;
  [k: string]: any;
}
export interface Links {
  [k: string]: string;
}
export interface Sources {
  /**
   * This interface was referenced by `Sources`'s JSON-Schema definition
   * via the `patternProperty` "\.\/.*".
   */
  [k: string]: SourceCode;
}
/**
 * The contract types included in this release
 */
export interface ContractTypes {
  [k: string]: ContractType;
}
/**
 * Data for a contract type included in this package
 *
 * This interface was referenced by `ContractTypes`'s JSON-Schema definition
 * via the `patternProperty` "[a-zA-Z][-a-zA-Z0-9_]{0,255}(?:\[[-a-zA-Z0-9]{1,256}\])?$".
 */
export interface ContractType {
  contract_name?: ContractName;
  deployment_bytecode?: BytecodeObject;
  runtime_bytecode?: BytecodeObject;
  abi?: Abi;
  natspec?: NatSpec;
  compiler?: CompilerInformation;
  [k: string]: any;
}
/**
 * The combined user-doc and dev-doc for this contract
 */
export interface NatSpec {
  [k: string]: any;
}
/**
 * Information about the software that was used to compile a contract type or instance
 */
export interface CompilerInformation {
  /**
   * The name of the compiler
   */
  name: string;
  /**
   * The version string for the compiler
   */
  version: string;
  /**
   * The settings used for compilation
   */
  settings?: {
    [k: string]: any;
  };
  [k: string]: any;
}
/**
 * The deployed contract instances in this release
 */
export interface Deployments {
  [k: string]: Deployment;
}
/**
 * This interface was referenced by `Deployments`'s JSON-Schema definition
 * via the `patternProperty` "^blockchain\://[0-9a-zA-Z]{64}/block/[0-9a-zA-Z]{64}$".
 */
export interface Deployment {
  [k: string]: ContractInstance;
}
/**
 * Data for a deployed instance of a contract
 *
 * This interface was referenced by `Deployment`'s JSON-Schema definition
 * via the `patternProperty` "^[a-zA-Z][a-zA-Z0-9_]{0,255}$".
 */
export interface ContractInstance {
  contract_type: ContractTypeName;
  address: Address;
  transaction?: TransactionHash;
  block?: BlockHash;
  runtime_bytecode?: BytecodeObject;
  compiler?: CompilerInformation;
  link_dependencies?: LinkDependencies;
  [k: string]: any;
}
export interface BuildDependencies {
  [k: string]: ContentUri;
}
